#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdlib.h>
#include <stdio.h>
#include <rtrdef.h>
#include "search.h"


static hitlist        hls;
static query          qry;
static rowdisp        row;
static rtselect       sel;
static response       rsp;
static command_parser prs;
highlight_word	      hlw_str[MAXQYTAGS];
colindexdetails	      col_str[MAXRETCOLS];
static long	      tkval;
short		      rord;

highlight_word	     *hlw[MAXQYTAGS];
colindexdetails      *col[MAXRETCOLS];

static short slot_num;

void end_work(int n)
{
  printf("\nERROR %d\n",n);
  
/*  trscqt(&hls,&qry,slot_num);	*/
  exit(0);
}


int init()
{
  int i;
  for(i=0;i<MAXQYTAGS;i++)
  {
    hlw[i]=&hlw_str[i];
  }
  for(i=0;i<MAXRETCOLS; i++)
  {
    col[i] = &col_str[i];
    col[i]->indexoptions = (oldindexopts*) malloc(sizeof(oldindexopts));
  }
}

int main(int argc, char* argv[])
{
  char  query_name[255];
  long  fid;
  char *login[]={"highlt",login_string,NULL};
  char  fname[255],hfname[255];

  if(argc<6) exit;
  strcpy(query_name,argv[1]);
  fid=atoi(argv[2]);
  sprintf(fname,"/tmp/hxr%d.prh",slot_num);
  strcpy(hfname,argv[5]);
  init();
  if(trscin(&hls,&qry,&prs,&slot_num,login,2)!=OK) end_work(1);
  if(trqmg1(&hls,&qry,&rsp,&sel,query_name)!=OK) end_work(2);
  if(trqeri(&hls,&qry,&sel,&prs)!=OK) end_work(3);
  if(trqern(&hls,&qry,&rsp,&sel,&prs,1)!=OK) end_work(4);
  if(trtdti(&hls,&rsp,&row,slot_num,fname,&rord,&tkval,col,1)!=OK) end_work(5);
  row.no=fid;
/*  if(trtdtd(&hls,&rsp,&row,fname,&rord,&tkval, 80, "NH")!=OK) end_work(6);*/

  if(trtdkd("search","doc",fid,fname,slot_num,80,0,&row,"NH")!=OK) end_work(8);
  if(trtdht(fname,hfname,hlw,col,1,argv[3],argv[4])!=OK) end_work(7);
  printf("DONE\n");
  trscqt(&hls,&qry,slot_num);	
  remove(fname);
}


