int str_len(string* str){return str->str_len;}
void str_cpy(string* str,char* txt)
{
  if(str->block_len==0)
  {
    str->block_len=strlen(txt)+16;
    str->string=(char*)malloc(str->block_len);
    strcpy(str->string,txt);
    str->str_len=strlen(txt);
  }
  else
  {
    str->block_len=strlen(txt)+16;
    str->string=(char*)realloc(str->string,str->block_len);
    strcpy(str->string,txt);
    str->str_len=strlen(txt);
  }
}
void str_append(string* str,char* txt)
{
  if(str->block_len==0)
  {
    str->block_len=strlen(txt)+16;
    str->string=(char*)malloc(str->block_len);
    strcpy(str->string,txt);
    str->str_len=strlen(txt);
  }
  else
  {
    if(str->block_len<=str->str_len+strlen(txt))
    {
      str->block_len=str->str_len+strlen(txt)+16;
      str->string=(char*)realloc(str->string,str->block_len);
      strcpy(str->string+str->str_len,txt);
      str->str_len+=strlen(txt);
    }
    else
    {
      strcpy(str->string+str->str_len,txt);
      str->str_len+=strlen(txt);
    }
  }
}
void str_prepend(string* str,char* txt)
{
  if(str->block_len==0)
  {
    str->block_len=strlen(txt)+16;
    str->string=(char*)malloc(str->block_len);
    strcpy(str->string,txt);
    str->str_len=strlen(txt);
  }
  else
  {
      char* new_str;
      str->str_len+=str_len(txt);
      str->block_len=str->str_len+16;
      new_str=(char*)malloc(str->block_len);
      strcpy(new_str,txt);
      strcat(new_str,str->string);
      free(str->string);
      str->string=new_str;
  }
}
void str_cat(string* a, string* b)
{
  if(b->string!=NULL) str_append(a,b->string);
}
void str_dup(string* a,string* b)
{
  if(b->string!=NULL) str_cpy(a,b->string);
}
void str_free(string* str)
{
  if(str->string!=NULL)
  {
    free(str->string);
    str->block_len=0;
    str->str_len=0;
  }
}
int get_next_word(string *str,string *substr,int pos)
{
  char* p1=NULL;
  int i,n=0;
  for(i=pos; i<str->str_len ; i++)
    if(str->string[i]>' ') break;
  if(i<str->str_len) p1=str->string+i;
  while(i+n<str->str_len && str->string[i+n]>' ') n++;
  str_free(substr);
  substr->block_len=n+16;
  substr->str_len=n;
  substr->string=(char*)malloc(substr->block_len);
  memcpy(substr->string,str->string+i,n);
  substr->string[n]='\0';
}
  
  
    
