/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[10];
};
static struct sqlcxp sqlfpn =
{
    9,
    "highlt.pc"
};


static unsigned long sqlctx = 0;


static struct sqlexd {
   unsigned long    sqlvsn;
   unsigned short   arrsiz;
   unsigned short   iters;
   unsigned short   offset;
   unsigned short   selerr;
   unsigned short   sqlety;
   unsigned short   unused;
            short  *cud;
   unsigned char   *sqlest;
            char   *stmt;
   unsigned char  **sqphsv;
   unsigned long   *sqphsl;
            short **sqpind;
   unsigned long   *sqparm;
   unsigned long  **sqparc;
   unsigned char   *sqhstv[3];
   unsigned long    sqhstl[3];
            short  *sqindv[3];
   unsigned long    sqharm[3];
   unsigned long   *sqharc[3];
} sqlstm = {4,3};
extern sqlcex(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlcte(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuf(/*_ char * _*/);
extern sqlora(/*_ unsigned long *, void * _*/);

static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern    sqliem();
/* cud (compilation unit data) array */
static short sqlcud0[] =
{3,34,
2,0,1,75,4,73,3,1,0,1,0,1,3,0,0,2,9,0,0,2,3,0,0,
25,0,2,45,4,76,2,1,0,1,0,1,3,0,0,2,3,0,0,
};

#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdlib.h>
#include <stdio.h>
#include <rtrdef.h>
#include "search.h"
/*#define left "<B><BLINK><font color=#ff0000>"
#define right "</font></BLINK></B>"*/

#define left "<B><font color=#ff0000>"
#define right "</font></B>"

static hitlist        hls;
static query          qry;
static rowdisp        row;
static rtselect       sel;
static response       rsp;
static command_parser prs;
highlight_word        hlw_str[MAXQYTAGS];
colindexdetails       col_str[MAXRETCOLS];
static long           tkval;
short                 rord;

highlight_word       *hlw[MAXQYTAGS];
colindexdetails      *col[MAXRETCOLS];

static short slot_num;

/* SQL stmt #1
EXEC SQL INCLUDE sqlca;
*/
/*
 * $Header: sqlca.h \
 * 1041000.1.1120.1 93/04/16 15:30:12 agadre Generic<unix> \
 * $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    VGokhale   04/16/93 -  Change longs to ints for DEC Alpha
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
#if defined(__osf__) && defined(__alpha)
         /* b4  */ int     sqlabc;
         /* b4  */ int     sqlcode;
#else
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
#endif
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
#if defined(__osf__) && defined(__alpha)
         /* b4  */ int     sqlerrd[6];
#else
         /* b4  */ long    sqlerrd[6];
#endif
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */

void end_work(int n)
{
  printf("\nERROR %d\n",n);
  
/*  trscqt(&hls,&qry,slot_num); */
  exit(0);
}


int init()
{
  int i;
  for(i=0;i<MAXQYTAGS;i++)
  {
    hlw[i]=&hlw_str[i];
  }
  for(i=0;i<MAXRETCOLS; i++)
  {
    col[i] = &col_str[i];
    col[i]->indexoptions = (oldindexopts*) malloc(sizeof(oldindexopts));
  }
}
int header(unsigned long id)
{
/* SQL stmt #2
  EXEC SQL BEGIN DECLARE SECTION;
*/
  long          fid;
  long          fsize;
struct {
  unsigned short len;
  unsigned char arr[255];
  } title;
/*
  VARCHAR       title[255];     
*/
  char          time[30];       
  long          ftype;
  long          grade;

/* SQL stmt #3
  EXEC SQL END DECLARE SECTION;
  EXEC SQL WHENEVER SQLERROR GOTO sqlerr;
  EXEC SQL WHENEVER NOTFOUND GOTO sqlerr;
*/
      
  fid = id;
  printf("<html><body bgcolor=\"#ffffff\"><center><table border=1 width=\"100%%\" cellspacing=2 cellpadding=2>\n");

/* SQL stmt #5
    EXEC SQL
      SELECT REPLACE(title,'""',''''),ftype INTO :title,:ftype FROM search WHERE fid=:fid;
*/
{
    sqlstm.stmt = "SELECT REPLACE(TITLE,'\"\"',''''),FTYPE INTO:b1,:b2 FROM SEARCH WHERE FID=:b3";
    sqlstm.iters = (unsigned short)1;
    sqlstm.offset = (unsigned short)2;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char *)&fid;
    sqlstm.sqhstl[0] = (unsigned long)4;
    sqlstm.sqindv[0] = (short *)0;
    sqlstm.sqharm[0] = (unsigned long)0;
    sqlstm.sqhstv[1] = (unsigned char *)&title;
    sqlstm.sqhstl[1] = (unsigned long)257;
    sqlstm.sqindv[1] = (short *)0;
    sqlstm.sqharm[1] = (unsigned long)0;
    sqlstm.sqhstv[2] = (unsigned char *)&ftype;
    sqlstm.sqhstl[2] = (unsigned long)4;
    sqlstm.sqindv[2] = (short *)0;
    sqlstm.sqharm[2] = (unsigned long)0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcex(&sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) goto sqlerr;
    if (sqlca.sqlcode < 0) goto sqlerr;
}

/* SQL stmt #6
    EXEC SQL
      SELECT grade INTO :grade FROM grade WHERE fid=:fid;
*/
{
    sqlstm.stmt = "SELECT GRADE INTO:b1 FROM GRADE WHERE FID=:b2";
    sqlstm.iters = (unsigned short)1;
    sqlstm.offset = (unsigned short)25;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char *)&fid;
    sqlstm.sqhstl[0] = (unsigned long)4;
    sqlstm.sqindv[0] = (short *)0;
    sqlstm.sqharm[0] = (unsigned long)0;
    sqlstm.sqhstv[1] = (unsigned char *)&grade;
    sqlstm.sqhstl[1] = (unsigned long)4;
    sqlstm.sqindv[1] = (short *)0;
    sqlstm.sqharm[1] = (unsigned long)0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcex(&sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) goto sqlerr;
    if (sqlca.sqlcode < 0) goto sqlerr;
}

    if (title.len > 255) 
        title.arr[255] = '\0';
    else
        title.arr[title.len] = '\0';
printf("<tr><td align=\"right\"><b>Title</b>:<td align=center><font size=\"+1\"><a href=\"http://tqd.advanced.org/%d\">%s</a></font>\n",
        fid,title.arr);
    printf("<tr><td align=right><b>Team No.</b>:<td>%d",fid);
    printf("<tr><td align=right><b>Grade</b>:<td>%d",grade);
    printf("<tr><td align=right><b>Category</b>:<td>%s",category[ftype]);

 sqlerr:        
  return;
}

void filecopy(FILE *ifp, FILE *ofp)
{
  int c;

  fprintf(ofp,"<tr><td align=right valign=\"top\"><b>Overview</b>:<td>\n");
  while ((c = getc(ifp)) != EOF)
    putc(c,ofp);
  fprintf(ofp,"\n</table></center></body></html>\n");
}

int main(int argc, char* argv[])
{
  char  query_name[255];
  long  fid = 0;
  char *login[]={"highlt",login_string,NULL};
  char  fname[255],hfname[255];
  FILE *fp,*hp;
  char  *buffer;                /* input string till first blank  */
  int i;

  if(getenv("ORACLE_HOME")==NULL) putenv("ORACLE_HOME=/usr/oracle");
  if(getenv("ORACLE_SID")==NULL) putenv("ORACLE_SID=nodb");

  printf("Content-type: text/html%c%c",10,10);

  buffer=(char*)malloc(strlen(getenv("QUERY_STRING"))+1);
  strcpy(buffer,getenv("QUERY_STRING"));

  for(i=0;buffer[i]!='\0';i++)   
    if (buffer[i]=='&') {
      strncpy(query_name,buffer,i);
      query_name[i+1] = '\0';
      fid=atol(buffer+i+1);
      sprintf(hfname,"tmp%d.out",slot_num);
      break;
    }
  if (fid == 0) {
    fid=atol(buffer);
    query_name[0] = '\0';
  }
  sprintf(fname,"tmp%d.in",slot_num);
  fflush(stdout);
  stdout_to_null();

  init();

  if(trscin(&hls,&qry,&prs,&slot_num,login,2)!=OK) end_work(1);

  if (query_name[0] != '\0') {
    if(trqmg1(&hls,&qry,&rsp,&sel,query_name)!=OK) end_work(2);
    if(trqeri(&hls,&qry,&sel,&prs)!=OK) end_work(3);
    if(trqern(&hls,&qry,&rsp,&sel,&prs,1)!=OK) end_work(4);
    if(trtdti(&hls,&rsp,&row,slot_num,fname,&rord,&tkval,col,1)!=OK) end_work(5);
  }
  row.no=fid;
  if(trtdkd("search","doc",fid,fname,slot_num,80,0,&row,"NH")!=OK) end_work(8);

  if ((query_name[0] == '\0') || (trtdht(fname,hfname,hlw,col,1,left,right)!=OK)) {
    fp = fopen(fname,"r");
  }
  else {
    fp = fopen(hfname,"r");
  }

  stdout_to_stdout();
  header(fid);
  filecopy(fp,stdout);

  fclose(fp);
  if (query_name[0] == '\0') remove(hfname);
  fflush(stdout);
  stdout_to_null();
  trscqt(&hls,&qry,slot_num);   
}


