#include <stdio.h>

static FILE   standard_out;
FILE * info_file=NULL;
static FILE * null=NULL;
static FILE * last=NULL;

void stdout_to_null()
{
  if(last==NULL)
    memcpy(&standard_out,stdout,sizeof(FILE));
  else
    memcpy(last,stdout,sizeof(FILE));
  if(null==NULL) if((null=fopen("/dev/null","w"))==NULL) exit(2);
  memcpy(stdout,null,sizeof(FILE));
  last=null;
}

void stdout_to_stdout()
{
  if(last==NULL) return;
  memcpy(last,stdout,sizeof(FILE));
  memcpy(stdout,&standard_out,sizeof(FILE));
  last=NULL;
}

void stdout_to_info()
{
  if(last==NULL)
    memcpy(&standard_out,stdout,sizeof(FILE));
  else
    memcpy(last,stdout,sizeof(FILE));
  if(info_file==NULL) if((info_file=tmpfile())==NULL) exit(3);
  memcpy(stdout,info_file,sizeof(FILE));
  last=info_file;
}
