
/* book_search.h */
/* constants for global options */
#define login_string "think/think"

#define NOT_EXPR        1l
#define AND_EXPR        2l
#define OR_EXPR         4l
#define T_EXPR          8l
#define FM_EXPR	       16l
#define SP_EXPR	       32l
#define SYN_EXPR       64l
#define RM_NONEX      128l
#define CONTAINS      256l
#define PRX_EXPR      512l
#define PHR_EXPR     1024l
#define PR_FLAG	     2048l
#define NEXT_OP	     4096l
#define CASE_SENS    8192l
#define FT          16384l
#define BT          32768l



typedef struct params
  {
    char		*param;
    long		value;
  } params;
  
  
typedef struct global_params
  {
    int   operand;
    int   case_sensitive;
    int   maxnum_hits;
    int   start_number;
    char* query_ID;
    char* info;
    char* query_text;
    char* document;
    char* proxy1;
    char* proxy2;
    int	  proxyd;
    long  options;
    long  total_num;
  } global_params;


extern char hilit_script_url[255];

extern char *category[]= {NULL,"Science and Math","Arts and Literature",
"Social Science","Sports","Interdisciplinary",NULL};
/* end of book_search.h */








