/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[12];
};
static struct sqlcxp sqlfpn =
{
    11,
    "proc_ora.pc"
};


static unsigned long sqlctx = 0;


static struct sqlexd {
   unsigned long    sqlvsn;
   unsigned short   arrsiz;
   unsigned short   iters;
   unsigned short   offset;
   unsigned short   selerr;
   unsigned short   sqlety;
   unsigned short   unused;
            short  *cud;
   unsigned char   *sqlest;
            char   *stmt;
   unsigned char  **sqphsv;
   unsigned long   *sqphsl;
            short **sqpind;
   unsigned long   *sqparm;
   unsigned long  **sqparc;
   unsigned char   *sqhstv[5];
   unsigned long    sqhstl[5];
            short  *sqindv[5];
   unsigned long    sqharm[5];
   unsigned long   *sqharc[5];
} sqlstm = {4,5};
extern sqlcex(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlcx2(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlcte(/*_ unsigned long *, struct sqlexd *, struct sqlcxp * _*/);
extern sqlbuf(/*_ char * _*/);
extern sqlora(/*_ unsigned long *, void * _*/);

 static char *sq0003 = 
"SELECT WL_WORD FROM SEARCH_WORD WHERE LOWER(WL_WORD)LIKE:b1           ";
 static char *sq0005 = 
"SELECT DISTINCT D.THS_WORD FROM THS_LINKS A,THS_LINKS B,SEARCH_WORD,THS_WORDS D WHERE A.THS_LNUM=B.THS_LNUM AND D.THS_WORDTAG=A.\
THS_LWORD1 AND B.THS_LWORD1=:b1           ";
static int IAPSUCC = 0;
static int IAPFAIL = 1403;
static int IAPFTL  = 535;
extern    sqliem();
/* cud (compilation unit data) array */
static short sqlcud0[] =
{3,34,
2,0,1,114,4,37,5,1,0,1,0,1,3,0,0,2,3,0,0,2,9,0,0,2,1,0,0,2,3,0,0,
33,0,2,65,4,62,1,0,0,1,0,2,3,0,0,
48,0,3,70,9,147,1,1,0,1,0,1,9,0,0,
63,0,3,0,13,152,1,0,0,1,0,2,9,0,0,
78,0,3,0,15,159,0,0,0,1,0,
89,0,4,82,4,178,2,1,0,1,0,1,9,0,0,2,3,0,0,
108,0,5,170,9,188,1,1,0,1,0,1,3,0,0,
123,0,5,0,13,197,1,0,0,1,0,2,9,0,0,
138,0,5,0,15,204,0,0,0,1,0,
149,0,6,70,4,218,2,1,0,1,0,1,9,0,0,2,3,0,0,
168,0,6,0,29,243,0,0,0,1,0,
179,0,7,46,5,244,2,2,0,1,0,1,9,0,0,1,9,0,0,
198,0,7,0,29,245,0,0,0,1,0,
209,0,8,65,3,248,2,2,0,1,0,1,9,0,0,1,9,0,0,
228,0,8,0,29,249,0,0,0,1,0,
239,0,9,49,3,254,2,2,0,1,0,1,9,0,0,1,9,0,0,
258,0,9,0,29,255,0,0,0,1,0,
269,0,10,51,4,267,2,1,0,1,0,1,9,0,0,2,9,0,0,
288,0,11,65,3,283,2,2,0,1,0,1,9,0,0,1,9,0,0,
307,0,11,0,29,284,0,0,0,1,0,
};

#ifdef RCSID
static char *RCSid='costamcostam';
#endif
#define TXRAPP
#define OK 0
#include <stdlib.h>
#include <stdio.h>
#include "rtrdef.h"
#include "search.h"
#include "redirections.h"

/* SQL stmt #1
EXEC SQL INCLUDE sqlca;
*/
/*
 * $Header: sqlca.h \
 * 1041000.1.1120.1 93/04/16 15:30:12 agadre Generic<unix> \
 * $ sqlca.h 
 */

/* Copyright (c) 1985,1986 by Oracle Corporation. */
 
/*
NAME
  SQLCA : SQL Communications Area.
FUNCTION
  Contains no code. Oracle fills in the SQLCA with status info
  during the execution of a SQL stmt.
NOTES
  If the symbol SQLCA_STORAGE_CLASS is defined, then the SQLCA
  will be defined to have this storage class. For example:
 
    #define SQLCA_STORAGE_CLASS extern
 
  will define the SQLCA as an extern.
 
  If the symbol SQLCA_INIT is defined, then the SQLCA will be
  statically initialized. Although this is not necessary in order
  to use the SQLCA, it is a good pgming practice not to have
  unitialized variables. However, some C compilers/OS's don't
  allow automatic variables to be init'd in this manner. Therefore,
  if you are INCLUDE'ing the SQLCA in a place where it would be
  an automatic AND your C compiler/OS doesn't allow this style
  of initialization, then SQLCA_INIT should be left undefined --
  all others can define SQLCA_INIT if they wish.

  If the symbol SQLCA_NONE is defined, then the SQLCA variable will
  not be defined at all.  The symbol SQLCA_NONE should not be defined
  in source modules that have embedded SQL.  However, source modules
  that have no embedded SQL, but need to manipulate a sqlca struct
  passed in as a parameter, can set the SQLCA_NONE symbol to avoid
  creation of an extraneous sqlca variable.
 
MODIFIED
    VGokhale   04/16/93 -  Change longs to ints for DEC Alpha
    losborne   08/11/92 -  No sqlca var if SQLCA_NONE macro set 
  Clare      12/06/84 - Ch SQLCA to not be an extern.
  Clare      10/21/85 - Add initialization.
  Bradbury   01/05/86 - Only initialize when SQLCA_INIT set
  Clare      06/12/86 - Add SQLCA_STORAGE_CLASS option.
*/
 
#ifndef SQLCA
#define SQLCA 1
 
struct   sqlca
         {
         /* ub1 */ char    sqlcaid[8];
#if defined(__osf__) && defined(__alpha)
         /* b4  */ int     sqlabc;
         /* b4  */ int     sqlcode;
#else
         /* b4  */ long    sqlabc;
         /* b4  */ long    sqlcode;
#endif
         struct
           {
           /* ub2 */ unsigned short sqlerrml;
           /* ub1 */ char           sqlerrmc[70];
           } sqlerrm;
         /* ub1 */ char    sqlerrp[8];
#if defined(__osf__) && defined(__alpha)
         /* b4  */ int     sqlerrd[6];
#else
         /* b4  */ long    sqlerrd[6];
#endif
         /* ub1 */ char    sqlwarn[8];
         /* ub1 */ char    sqlext[8];
         };

#ifndef SQLCA_NONE 
#ifdef   SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
         struct sqlca sqlca
#endif
 
#ifdef  SQLCA_INIT
         = {
         {'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
         sizeof(struct sqlca),
         0,
         { 0, {0}},
         {'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
         {0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0},
         {0, 0, 0, 0, 0, 0, 0, 0}
         }
#endif
         ;
#endif
 
#endif
 
/* end SQLCA */

void end_work(int n)
{
  printf("\nERROR %d\n",n);
  exit(0);
}

int output_body(unsigned long * hls, global_params *glp)
{
  int i=0;
/* SQL stmt #2
  EXEC SQL BEGIN DECLARE SECTION;
*/
  long          fid;
  long          fsize;
struct {
  unsigned short len;
  unsigned char arr[255];
  } title;
/*
  VARCHAR       title[255];     
*/
  char          time[30];       
  long          ftype;

/* SQL stmt #3
  EXEC SQL END DECLARE SECTION;
  EXEC SQL WHENEVER SQLERROR GOTO sqlerr;
  EXEC SQL WHENEVER NOTFOUND GOTO sqlerr;
*/
      printf("<center><table border=1 width=\"100%%\">\n");
        printf("<tr><th>No.<th>Title<th>Category<th>Team URL<th>Size(KB)\n");
  while((fid=hls[i++])>0)
  {
/* SQL stmt #5
    EXEC SQL
      SELECT
        fsize,REPLACE(title,'""',''''),to_char(time,'mm/dd/yy'),ftype
      INTO :fsize,:title,:time,:ftype FROM search WHERE fid=:fid;
*/
{
    sqlstm.stmt = "SELECT FSIZE,REPLACE(TITLE,'\"\"',''''),TO_CHAR(TIME,'mm/dd/yy'),FTYPE INTO:b1,:b2,:b3,:b4 FROM SEARCH WHERE \
FID=:b5";
    sqlstm.iters = (unsigned short)1;
    sqlstm.offset = (unsigned short)2;
    sqlstm.selerr = (unsigned short)0;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char *)&fid;
    sqlstm.sqhstl[0] = (unsigned long)4;
    sqlstm.sqindv[0] = (short *)0;
    sqlstm.sqharm[0] = (unsigned long)0;
    sqlstm.sqhstv[1] = (unsigned char *)&fsize;
    sqlstm.sqhstl[1] = (unsigned long)4;
    sqlstm.sqindv[1] = (short *)0;
    sqlstm.sqharm[1] = (unsigned long)0;
    sqlstm.sqhstv[2] = (unsigned char *)&title;
    sqlstm.sqhstl[2] = (unsigned long)257;
    sqlstm.sqindv[2] = (short *)0;
    sqlstm.sqharm[2] = (unsigned long)0;
    sqlstm.sqhstv[3] = (unsigned char *)time;
    sqlstm.sqhstl[3] = (unsigned long)30;
    sqlstm.sqindv[3] = (short *)0;
    sqlstm.sqharm[3] = (unsigned long)0;
    sqlstm.sqhstv[4] = (unsigned char *)&ftype;
    sqlstm.sqhstl[4] = (unsigned long)4;
    sqlstm.sqindv[4] = (short *)0;
    sqlstm.sqharm[4] = (unsigned long)0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcex(&sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) goto sqlerr;
    if (sqlca.sqlcode < 0) goto sqlerr;
}
    time[11]='\0';
    if(title.len>255) break;
     title.arr[title.len] = '\0';
     printf("<tr><td>%d",i+glp->start_number-1);
    printf("<td><a href=\"%s?%s&%ld\" target=\"bottom\">",hilit_script_url,glp->query_ID,fid);
    printf("%s</a>",title.arr);
        printf("<td>%s",category[ftype]);
    printf("<td><a href=\"http://tqd.advanced.org/%d\">http://tqd.advanced.org/%d</a></td>",fid,fid);
    if(fsize>0) printf("<td align=center>%5.1f</td>",(float)fsize/1024.0);
    /*printf("<td>%s\n",time);*/
  }
  printf("</table></center>");
 sqlerr:        
  return;
}

long get_unique_number()
{
/* SQL stmt #7
  EXEC SQL BEGIN DECLARE SECTION;
*/
    long        number;
/* SQL stmt #8
  EXEC SQL END DECLARE SECTION;
  EXEC SQL
    SELECT query_seq.NEXTVAL INTO :number
    FROM USER_TABLES WHERE ROWNUM<=1 ;
*/
{
  sqlstm.stmt = "SELECT QUERY_SEQ.NEXTVAL INTO:b1 FROM USER_TABLES WHERE ROWNUM<=1";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)33;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&number;
  sqlstm.sqhstl[0] = (unsigned long)4;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) goto sqlerr;
  if (sqlca.sqlcode < 0) goto sqlerr;
}
  return number;
 sqlerr:
  return 0;
}

static hitlist        hls;
static query          qry;
static rowdisp        row;
static rtselect       sel;
static response       rsp;
static command_parser prs;
static short slot_num;
char   tmp[80]="SELECT fid FROM search WHERE \n";

void populate_hl(unsigned long* hits, global_params *glp)
{
  long max_num,i;

  glp->total_num=hls.count;
  max_num=glp->start_number+glp->maxnum_hits-1;
  if(max_num>hls.count) max_num=hls.count;
  for(i=glp->start_number;i<=max_num;i++)
  {
    row.no=i;
    trtgtk(&hls,&row,&hits[i-glp->start_number]);
  }
  hits[i]=0;
}

int find_nxt_hits(unsigned long* hits, global_params *glp)
{
  long max_num,i;
  if(trqmr1(&hls,&qry,&rsp,&sel,glp->query_ID)!=OK) return 1;
  populate_hl(hits,glp);
  return 0;
}

int find_hits(char* query_string, unsigned long* hits, global_params *glp)
{
  long  i,max_num;
  if(trxtlq(&hls,&qry,&sel,query_string) != OK) end_work(2);
  if(trqeri(&hls,&qry,&sel,&prs) != OK) end_work(3);
  trqern(&hls,&qry,&rsp,&sel,&prs,0);
  if(hls.count!=0)
  {
    static char string[32];
    long l;
    l=get_unique_number();
    sprintf(string,"srch_%ld",l);
    glp->query_ID=string;
    trqmd1(&rsp,string);
    trqms1(&hls,&qry,&rsp,slot_num,string,qry.num);
  }
  insert_visit();
  populate_hl(hits,glp);
}


int init_sql()
{
  char  *table[]= {"web_search",login_string,NULL};
  if(trscin(&hls,&qry,&prs,&slot_num,table,2)!=OK) end_work(7);
}

int end_sql()
{
  trscqt(&hls,&qry,slot_num);
}


char* find_matching_words(char* word)
{
/* SQL stmt #10
  EXEC SQL BEGIN DECLARE SECTION;
    VARCHAR     wd[255];
*/
struct {
  unsigned short len;
  unsigned char arr[255];
  } wd;
/* SQL stmt #11
  EXEC SQL END DECLARE SECTION;
*/
  static char* string;
  wd.len=sprintf(wd.arr,"%s",word);
  string=(char*)malloc(2*sizeof(char));
/* SQL stmt #12
  EXEC SQL WHENEVER SQLERROR GOTO sqlerror;
  EXEC SQL DECLARE curs CURSOR FOR
    SELECT wl_word FROM search_word
      WHERE LOWER(wl_word) LIKE :wd;
  EXEC SQL OPEN curs;
*/
{
  sqlstm.stmt = sq0003;
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)48;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&wd;
  sqlstm.sqhstl[0] = (unsigned long)257;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerror;
}
/* SQL stmt #15
  EXEC SQL WHENEVER NOTFOUND GOTO notfound;
*/
  strcpy(string,"");
  for(;;)
  {
/* SQL stmt #16
    EXEC SQL FETCH curs INTO :wd;
*/
{
    sqlstm.iters = (unsigned short)1;
    sqlstm.offset = (unsigned short)63;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char *)&wd;
    sqlstm.sqhstl[0] = (unsigned long)257;
    sqlstm.sqindv[0] = (short *)0;
    sqlstm.sqharm[0] = (unsigned long)0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcex(&sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) goto notfound;
    if (sqlca.sqlcode < 0) goto sqlerror;
}
    wd.arr[wd.len]='\0';
    string=(char*)realloc(string,(strlen(string)+wd.len+3)*sizeof(char));
    strcat(string," ");
    strcat(string,wd.arr);
  }
 notfound:
/* SQL stmt #17
  EXEC SQL CLOSE curs;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)78;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerror;
}
  return string;
 sqlerror:
  exit(1);
}

char* find_synonyms(char* word)
{
  static char* word_str = NULL;
  long word_str_size=1*sizeof(char);
/* SQL stmt #18
  EXEC SQL BEGIN DECLARE SECTION;
*/
    long        wordtag;
/*
    varchar     wordname[250];
*/
struct {
  unsigned short len;
  unsigned char arr[250];
  } wordname;
/*
    varchar     synonym[250];
*/
struct {
  unsigned short len;
  unsigned char arr[250];
  } synonym;
/* SQL stmt #19
  EXEC SQL END DECLARE SECTION;
*/

  wordname.len=sprintf(wordname.arr,"%s",word);
  
/* SQL stmt #20
  EXEC SQL WHENEVER NOT FOUND GOTO sqlerror;
  EXEC SQL
    SELECT ths_wordtag INTO :wordtag FROM ths_words
      WHERE  ths_word = :wordname AND ths_wtype IS NULL;
*/
{
  sqlstm.stmt = "SELECT THS_WORDTAG INTO:b1 FROM THS_WORDS WHERE THS_WORD=:b2 AND THS_WTYPE IS NULL";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)89;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&wordname;
  sqlstm.sqhstl[0] = (unsigned long)252;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&wordtag;
  sqlstm.sqhstl[1] = (unsigned long)4;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) goto sqlerror;
  if (sqlca.sqlcode < 0) goto sqlerror;
}
/* SQL stmt #22
  EXEC SQL DECLARE wd CURSOR FOR
    SELECT DISTINCT d.ths_word 
      FROM ths_links a, ths_links b ,search_word, ths_words d 
      WHERE 
        a.ths_lnum=b.ths_lnum AND 
        d.ths_wordtag=a.ths_lword1 AND 
        b.ths_lword1=:wordtag;
  EXEC SQL OPEN wd;
*/
{
  sqlstm.stmt = sq0005;
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)108;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&wordtag;
  sqlstm.sqhstl[0] = (unsigned long)4;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerror;
}

  if(word_str==NULL) word_str=(char*)malloc(word_str_size);
  else word_str=(char*)realloc(word_str,word_str_size);
  strcpy(word_str,"");

  for(;;)
  {
/* SQL stmt #24
    EXEC SQL WHENEVER NOT FOUND DO break;
    EXEC SQL FETCH wd INTO :synonym;
*/
{
    sqlstm.iters = (unsigned short)1;
    sqlstm.offset = (unsigned short)123;
    sqlstm.cud = sqlcud0;
    sqlstm.sqlest = (unsigned char *)&sqlca;
    sqlstm.sqlety = (unsigned short)0;
    sqlstm.sqhstv[0] = (unsigned char *)&synonym;
    sqlstm.sqhstl[0] = (unsigned long)252;
    sqlstm.sqindv[0] = (short *)0;
    sqlstm.sqharm[0] = (unsigned long)0;
    sqlstm.sqphsv = sqlstm.sqhstv;
    sqlstm.sqphsl = sqlstm.sqhstl;
    sqlstm.sqpind = sqlstm.sqindv;
    sqlstm.sqparm = sqlstm.sqharm;
    sqlstm.sqparc = sqlstm.sqharc;
    sqlcex(&sqlctx, &sqlstm, &sqlfpn);
    if (sqlca.sqlcode == 1403) break;
    if (sqlca.sqlcode < 0) goto sqlerror;
}
    synonym.arr[synonym.len]='\0';
    word_str=(char*)realloc(word_str,strlen(word_str)+synonym.len+2);
    if(word_str==NULL) return "";
    strcat(word_str," ");
    strcat(word_str,synonym.arr);
  }
/* SQL stmt #26
  EXEC SQL CLOSE wd;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)138;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto sqlerror;
}
  return word_str;
 sqlerror:
  return "";
}

int not_exist(char* word)
{
/* SQL stmt #27
  EXEC SQL BEGIN DECLARE SECTION;
*/
    long        wl_fr;
/*
    varchar     wordname[250];
*/
struct {
  unsigned short len;
  unsigned char arr[250];
  } wordname;
/* SQL stmt #28
  EXEC SQL END DECLARE SECTION;
*/
  wordname.len=sprintf(wordname.arr,"%s",word);
/* SQL stmt #29
  EXEC SQL WHENEVER NOT FOUND GOTO sqlerror;
  EXEC SQL
    SELECT wl_freq INTO :wl_fr FROM search_word
      WHERE wl_word=:wordname AND
            ROWNUM = 1;
*/
{
  sqlstm.stmt = "SELECT WL_FREQ INTO:b1 FROM SEARCH_WORD WHERE WL_WORD=:b2 AND ROWNUM=1";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)149;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&wordname;
  sqlstm.sqhstl[0] = (unsigned long)252;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&wl_fr;
  sqlstm.sqhstl[1] = (unsigned long)4;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) goto sqlerror;
  if (sqlca.sqlcode < 0) goto sqlerror;
}
  return 0;
 sqlerror:
  return 1;
}
  
void save_info(char* info_name, char* info_str)
{
/* SQL stmt #31
  EXEC SQL BEGIN DECLARE SECTION;
    VARCHAR     in_name[50];
*/
struct {
  unsigned short len;
  unsigned char arr[50];
  } in_name;
/*
    VARCHAR     in[2000];
*/
struct {
  unsigned short len;
  unsigned char arr[2000];
  } in;
/*
    VARCHAR     host[200];
*/
struct {
  unsigned short len;
  unsigned char arr[200];
  } host;
struct {
  unsigned short len;
  unsigned char arr[200];
  } user_agent;
/*
    VARCHAR     user_agent[200];   
  EXEC SQL END DECLARE SECTION;
*/
  in_name.len=sprintf(in_name.arr,"%s",info_name);
  if(strlen(info_str)>2000) info_str[1999]='\0';
  in.len=sprintf(in.arr,"%s",info_str);
  host.len=sprintf(host.arr,"%s",getenv("REMOTE_HOST"));
  user_agent.len=sprintf(user_agent.arr,"%s",getenv("HTTP_USER_AGENT"));

/* SQL stmt #33
  EXEC SQL WHENEVER SQLERROR GOTO error;
  EXEC SQL WHENEVER NOT FOUND GOTO error;
  EXEC SQL COMMIT;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)168;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto error;
}
/* SQL stmt #36
  EXEC SQL UPDATE search_info SET info=:in WHERE name=:in_name;
*/
{
  sqlstm.stmt = "UPDATE SEARCH_INFO SET INFO=:b1 WHERE NAME=:b2";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)179;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&in;
  sqlstm.sqhstl[0] = (unsigned long)2002;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&in_name;
  sqlstm.sqhstl[1] = (unsigned long)52;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode == 1403) goto error;
  if (sqlca.sqlcode < 0) goto error;
}
/* SQL stmt #37
  EXEC SQL COMMIT;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)198;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto error;
}
/* SQL stmt #38
  EXEC SQL WHENEVER SQLERROR CONTINUE;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;
  EXEC SQL INSERT INTO env_table (remote_host,http_user_agent) VALUES (:host,:user_agent);
*/
{
  sqlstm.stmt = "INSERT INTO ENV_TABLE(REMOTE_HOST,HTTP_USER_AGENT)VALUES(:b1,:b2)";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)209;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&host;
  sqlstm.sqhstl[0] = (unsigned long)202;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&user_agent;
  sqlstm.sqhstl[1] = (unsigned long)202;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
/* SQL stmt #41
  EXEC SQL COMMIT;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)228;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
  return;
 error:
/* SQL stmt #42
  EXEC SQL WHENEVER SQLERROR CONTINUE;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;
  EXEC SQL INSERT INTO search_info (name,info) VALUES (:in_name,:in);
*/
{
  sqlstm.stmt = "INSERT INTO SEARCH_INFO(NAME,INFO)VALUES(:b1,:b2)";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)239;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&in_name;
  sqlstm.sqhstl[0] = (unsigned long)52;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&in;
  sqlstm.sqhstl[1] = (unsigned long)2002;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
/* SQL stmt #45
  EXEC SQL COMMIT;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)258;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
}

char * retrive_info(char* info_name)
{
/* SQL stmt #46
  EXEC SQL BEGIN DECLARE SECTION;
    varchar             in_name[32];
*/
struct {
  unsigned short len;
  unsigned char arr[32];
  } in_name;
    static 
/*
varchar      in[2000];
*/
struct {
  unsigned short len;
  unsigned char arr[2000];
  } in;
/* SQL stmt #47
  EXEC SQL END DECLARE SECTION;
*/
  in_name.len=sprintf(in_name.arr,"%s",info_name);
/* SQL stmt #48
  EXEC SQL WHENEVER SQLERROR CONTINUE;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;
  EXEC SQL SELECT info INTO :in FROM search_info WHERE name=:in_name;
*/
{
  sqlstm.stmt = "SELECT INFO INTO:b1 FROM SEARCH_INFO WHERE NAME=:b2";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)269;
  sqlstm.selerr = (unsigned short)0;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&in_name;
  sqlstm.sqhstl[0] = (unsigned long)34;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&in;
  sqlstm.sqhstl[1] = (unsigned long)2002;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
  in.arr[in.len]='\0';
  return in.arr;
}
  
int insert_visit()
{
/* SQL stmt #51
  EXEC SQL BEGIN DECLARE SECTION;
    VARCHAR     host[200];
*/
struct {
  unsigned short len;
  unsigned char arr[200];
  } host;
struct {
  unsigned short len;
  unsigned char arr[200];
  } user_agent;
/*
    VARCHAR     user_agent[200];   
  EXEC SQL END DECLARE SECTION;
*/
  host.len=sprintf(host.arr,"%s",getenv("REMOTE_HOST"));
  user_agent.len=sprintf(user_agent.arr,"%s",getenv("HTTP_USER_AGENT"));

/* SQL stmt #53
  EXEC SQL WHENEVER SQLERROR CONTINUE;
  EXEC SQL WHENEVER NOT FOUND CONTINUE;
  EXEC SQL INSERT INTO env_table (remote_host,http_user_agent) VALUES (:host,:user_agent);
*/
{
  sqlstm.stmt = "INSERT INTO ENV_TABLE(REMOTE_HOST,HTTP_USER_AGENT)VALUES(:b1,:b2)";
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)288;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlstm.sqhstv[0] = (unsigned char *)&host;
  sqlstm.sqhstl[0] = (unsigned long)202;
  sqlstm.sqindv[0] = (short *)0;
  sqlstm.sqharm[0] = (unsigned long)0;
  sqlstm.sqhstv[1] = (unsigned char *)&user_agent;
  sqlstm.sqhstl[1] = (unsigned long)202;
  sqlstm.sqindv[1] = (short *)0;
  sqlstm.sqharm[1] = (unsigned long)0;
  sqlstm.sqphsv = sqlstm.sqhstv;
  sqlstm.sqphsl = sqlstm.sqhstl;
  sqlstm.sqpind = sqlstm.sqindv;
  sqlstm.sqparm = sqlstm.sqharm;
  sqlstm.sqparc = sqlstm.sqharc;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
/* SQL stmt #56
  EXEC SQL COMMIT;
*/
{
  sqlstm.iters = (unsigned short)1;
  sqlstm.offset = (unsigned short)307;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char *)&sqlca;
  sqlstm.sqlety = (unsigned short)0;
  sqlcex(&sqlctx, &sqlstm, &sqlfpn);
}
  return;
}










