truncate table search_urls;
drop table search_urls;
create table search_urls (
	host_id 	number(6),	-- id of http server
	prot    	varchar2(10),	
	host    	varchar2(60),
	path    	varchar2(250),
	flag   		char(1),    --0..4,R,U	
	priority   	number(2),	-- determines priority of loading
	depth		number(2),	-- depth from root
	fid     	number(8)    
);                          
                          
	
drop index i_search_urls;
create unique index i_search_urls on search_urls(host_id,path);

truncate table search_urls_temp;
drop table search_urls_temp;
create table search_urls_temp (
	host_id 	number(6),	-- id of http server
	prot    	varchar2(10),	
	host    	varchar2(60),
	path    	varchar2(250),
	flag   		char(1),	
	priority   	number(2),	-- determines priority of loading
	depth		number(2),	-- depth from root
	fid     	number(8)
);
	
drop index i_search_urls_temp;
create unique index i_search_urls_temp on search_urls_temp(host_id,path);

truncate table search_disallow;
drop table search_disallow;
create table search_disallow (
	host_id      	number(6),	-- id of http server
	path     	varchar2(250)	-- disallowed path
);
drop index i_search_disallow;
create index i_search_disallow on search_disallow(host_id);

truncate table search_hosts;
drop table search_hosts;
create table search_hosts (
	host_id      	number(6),	-- id of http server
	host     	varchar2(60) constraint pk_host primary key,	-- unique hostname:port
	time     	number(12),	-- time of last reading of robot.txt
	flag     	number(1)
);
	
truncate table search_info;
drop table search_info;
create table search_info (
	name     	varchar2(32),	-- name of stored SQE
	info     	varchar2(2000)	-- information returned by TextRetrival
);











