SQL> 1;
  1* select TEXT from user_source where name='PARSE'
SQL> select TEXT from user_source where name='PARSE';

TEXT                                                                            
--------------------------------------------------------------------------------
package parse is                                                                
type check_table is table of varchar2(30) index by binary_integer;              
type or_table is table of number(6) index by binary_integer;                    
check_vec check_table;                                                          
or_num or_table;                                                                
con_name check_table;                                                           
tot_param NUMBER := 0;                                                          
tot_fids NUMBER := 0;                                                           
row_count NUMBER := 0;                                                          
done NUMBER := 0;                                                               
tot_hits NUMBER := 0;                                                           

TEXT                                                                            
--------------------------------------------------------------------------------
ht_num NUMBER;                                                                  
end_num NUMBER;                                                                 
procedure resform(query_text in varchar2);                                      
procedure ini_page ;                                                            
procedure entry(query_text in varchar2,type in number,category in number,       
                      doc in number,condition in number,max_hits in number,     
                      start_num in number,host varchar2,user_agent varchar2);   
procedure searchresult(query_text in varchar2,type in number,category in number,
                                                                                
                                                                                
               doc in number,condition in number,max_hits in number,start_num in

TEXT                                                                            
--------------------------------------------------------------------------------
 number);                                                                       
                                                                                
procedure table_row(c_name   search%rowtype,k in number);                       
procedure convert(val in number);                                               
function wd_and(title in varchar2,num in number) return boolean;                
procedure wd_cate_or(lo in number,hi in number);                                
function dupli_fid(val in number) return boolean;                               
function sig(query_text in varchar2,type in number,category in number,          
                 doc in number, condition in number,max_hits in number,         
                end_num in number) return varchar2;                             
function sigpre(alt in varchar2,type in number, category in number,             

TEXT                                                                            
--------------------------------------------------------------------------------
              doc in number,condition in number,max_hits in number,end_num in nu
mber)                                                                           
                                                                                
           return varchar2;                                                     
function makestr  return varchar2;                                              
function print_result(cur_search in search%rowtype,j in number,start_num in numb
er,                                                                             
                                                                                
               max_hits in number) return number;                               
procedure signature(alt in varchar2,type in number,category in number,doc in num
ber,                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
condition in number,max_hits in number,k in number, start_num in number);       
procedure by_team(query_text in varchar2);                                      
end;                                                                            
package body parse is                                                           
-------------------------------------------------------------------------       
procedure resform(query_text in varchar2) is                                    
the_word varchar2(200) := LTRIM(RTRIM(query_text));                             
first_space NUMBER := INSTR(the_word, ' ');                                     
last_space  NUMBER;                                                             
next_space  NUMBER := first_space;                                              

TEXT                                                                            
--------------------------------------------------------------------------------
new_word varchar2(200);                                                         
begin                                                                           
  if (first_space = 0) then                                                     
       tot_param := 1;                                                          
       check_vec(1) := query_text;                                              
  elsif(first_space != 0)  then                                                 
      last_space := INSTR(the_word,' ',-1,1);                                   
      if (first_space = last_space) then                                        
            check_vec(1) := SUBSTR(the_word,1,first_space-1);                   
            check_vec(2) := SUBSTR(the_word,first_space+1);                     
            tot_param := 2;                                                     

TEXT                                                                            
--------------------------------------------------------------------------------
      else                                                                      
            check_vec(1) := SUBSTR(the_word,1,first_space-1);                   
            tot_param := tot_param + 1;                                         
            new_word := LTRIM(SUBSTR(the_word,first_space+1));                  
           <<loop_one>>                                                         
            while (next_space != last_space) loop                               
                    next_space := INSTR(new_word, ' ');                         
                    if (next_space >0) then                                     
                       check_vec(tot_param + 1) := SUBSTR(new_word,1,next_space-
1);                                                                             
                                                                                

TEXT                                                                            
--------------------------------------------------------------------------------
                       tot_param := tot_param + 1;                              
                       new_word :=  LTRIM(SUBSTR(new_word,next_space+1));       
                    else                                                        
                       exit loop_one;                                           
                    end if;                                                     
             end loop;                                                          
             check_vec(tot_param + 1) := new_word;                              
             tot_param := tot_param + 1;                                        
      end if;                                                                   
 /* else                                                                        
     htp.p('Not implemented');  */                                              

TEXT                                                                            
--------------------------------------------------------------------------------
  end if;                                                                       
end;                                                                            
-------------------------------------------------------------------------       
procedure ini_page is                                                           
begin                                                                           
    htp.p('<center>');                                                          
    --htp.formOpen('http://kayak.npac.syr.edu:1963/cgi-bin/think/think_quest.pl'
,'GET');                                                                        
                                                                                
	htp.formOpen('http://kayak.npac.syr.edu:1963/cgi-bin/think/tq.pl','GET');      
    htp.bold('ThinkQuest Search '||' '||htf.formText('query_text',35));         

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.p('<input type=image src="http://kayak.npac.syr.edu:1963/search/search.j
peg" border=0 align="top">');                                                   
                                                                                
    htp.anchor('http://kayak.npac.syr.edu:1963/think/help.html','Help',cattribut
es=>'TARGET="bottom"');                                                         
                                                                                
    htp.p('<br><font size="-1"><b>Domain</b>:');                                
    htp.formSelectOpen('db');                                                   
    htp.formSelectOption('TQ Proposals',cattributes=>'Value="1"');              
    htp.formSelectOption('ANS Web Pages',cattributes=>'Value="2"');             
    htp.formSelectClose;                                                        

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.formSelectOpen('type');                                                 
    htp.formSelectOption('Document',cattributes=>'Value="3"');                  
    htp.formSelectOption('Title',cattributes=>'Value="2"');                     
    htp.formSelectOption('List',cattributes=>'Value="4"');                      
    htp.formSelectOption('Team No.',cattributes=>'Value="5"');                  
    htp.formSelectClose;                                                        
    htp.formSelectOpen('category');                                             
    htp.formSelectOption('All','SELECTED',cattributes=>'Value="*"');            
    htp.formSelectOption('Science and Math',cattributes=>'Value="1"');          
    htp.formSelectOption('Arts and Literature',cattributes=>'Value="2"');       
    htp.formSelectOption('Social Science',cattributes=>'Value="3"');            

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.formSelectOption('Sports',cattributes=>'Value="4"');                    
    htp.formSelectOption('Interdisciplinary',cattributes=>'Value="5"');         
    htp.formSelectClose;                                                        
    htp.p('<br><b>Options</b>:');                                               
    htp.formSelectOpen('normal_options');                                       
    htp.formSelectOption('Match','SELECTED',cattributes=>'Value="contains"');   
    htp.formSelectOption('Not Match',cattributes=>'Value="n_contains"');        
    htp.formSelectClose;                                                        
    htp.formSelectOpen('normal_options');                                       
    htp.formSelectOption('All words','SELECTED',cattributes=>'Value="and"');    
    htp.formSelectOption('Any word',cattributes=>'Value="or"');                 

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.formSelectClose;                                                        
    htp.bold('Hits/Page:');                                                     
    htp.formSelectOpen('max_hits');                                             
    htp.formSelectOption('5',cattributes=>'Value="5"');                         
    htp.formSelectOption('10','SELECTED',cattributes=>'Value="10"');            
    htp.formSelectOption('20',cattributes=>'Value="20"');                       
    htp.formSelectOption('30',cattributes=>'Value="30"');                       
    htp.formSelectOption('40',cattributes=>'Value="40"');                       
    htp.formSelectOption('100',cattributes=>'Value="100"');                     
    htp.formSelectClose;                                                        
    htp.formHidden('subm_option','normal');                                     

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.formHidden('mode','normal');                                            
    htp.formHidden('normal_options','case_s');                                  
    htp.formHidden('start_num',1);                                              
 htp.formClose;                                                                 
 htp.p('</font><hr>');                                                          
 htp.p('<I>NPAC, Syracuse University, <a href="mailto:gcheng@npac.syr.edu">G. Ch
eng</a>, <a href="mailto:tapulika@npac.syr.edu">T. Pulikal</a> and <a href="mail
to:piotr@npac.syr.edu">P. Sokilowski.</A> </I>');                               
                                                                                
  htp.p('</CENTER>');                                                           
end;                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
procedure by_team(query_text in varchar2) is                                    
cursor cteam(tid varchar2) is select * from SEARCH where to_char(fid)=tid;      
srch search%rowtype;                                                            
begin                                                                           
	open cteam(replace(query_text,' '));                                           
	fetch cteam into srch;                                                         
	 tot_hits := 0;                                                                
        if cteam%FOUND then                                                     
		table_row(srch,1);                                                            
		 tot_hits := 1;                                                               
	end if;                                                                        

TEXT                                                                            
--------------------------------------------------------------------------------
	close cteam;                                                                   
end;                                                                            
----------------------------------------------------------------------------    
procedure entry(query_text in varchar2,type in number,category in number,       
                      doc in number,condition in number,max_hits in number,     
                      start_num in number,host varchar2,user_agent varchar2) is 
begin                                                                           
	insert into env_table(ttime,remote_host,http_user_agent) values(sysdate,lower(h
ost),user_agent);                                                               
                                                                                
	commit;                                                                        

TEXT                                                                            
--------------------------------------------------------------------------------
	searchresult(query_text,type,category,doc,condition,max_hits,start_num);       
end;                                                                            
procedure searchresult(query_text in varchar2,type in number,category in number,
                                                                                
                                                                                
                      doc in number,condition in number,max_hits in number,     
                      start_num in number) is                                   
cursor c_kwd_cate(k_word in varchar2,lo in number,hi in number) is              
               select * from SEARCH                                             
                where  ((upper(TITLE) like '%'||upper(k_word)||'%') AND         
                       (FTYPE BETWEEN lo AND hi))                               

TEXT                                                                            
--------------------------------------------------------------------------------
                order by FTYPE,TITLE;                                           
cursor c_kwdnot_cate(k_word in varchar2,lo in number,hi in number) is           
               select * from SEARCH                                             
                where (NOT(upper(TITLE) like '%'||upper(k_word)||'%') AND       
                       (FTYPE BETWEEN lo AND hi))                               
                order by FTYPE,TITLE;                                           
cursor c_cate_list(lo in number,hi in number) is                                
                  select * from SEARCH                                          
                              where (FTYPE BETWEEN lo AND hi)                   
                               order by FTYPE;                                  
cur_search search%rowtype;                                                      

TEXT                                                                            
--------------------------------------------------------------------------------
srch search%rowtype;                                                            
i number;                                                                       
k number := 0;                                                                  
j NUMBER := 0;                                                                  
cnt NUMBER;                                                                     
lo NUMBER;                                                                      
hi NUMBER;                                                                      
alt varchar2(2000) := 'test';                                                   
begin                                                                           
htp.htmlOpen;                                                                   
 htp.headOpen;                                                                  

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.title('ThinkQuest Project Search Results');                             
 htp.headClose;                                                                 
    --htp.bodyOpen(cattributes=>'bgcolor="White"');                             
 htp.bodyOpen;                                                                  
 parse.resform(query_text);                                                     
 htp.p('<center>');                                                             
 htp.tableOpen('BORDER',cattributes=>'WIDTH="100%"');                           
    htp.tableRowOpen('LEFT','MIDDLE');                                          
    htp.tableHeader('No.','MIDDLE');                                            
    htp.tableHeader('Team','MIDDLE');                                           
    htp.tableHeader('Title','CENTER','NOWRAP',cattributes=>'valign="MIDDLE"');  

TEXT                                                                            
--------------------------------------------------------------------------------
    htp.tableHeader('Category','CENTER','NOWRAP ',cattributes=>'valign="MIDDLE"'
);                                                                              
                                                                                
    htp.tableHeader('Size(KB)','CENTER','NOWRAP',cattributes=>'valign="MIDDLE"')
;                                                                               
                                                                                
    htp.tableHeader('Last Update','CENTER','MIDDLE');                           
 if (type=5) then                                                               
	by_team(query_text);                                                           
	htp.tableClose;                                                                
	k := 2;                                                                        

TEXT                                                                            
--------------------------------------------------------------------------------
	goto end_of_table;                                                             
 end if;                                                                        
 end_num := start_num + max_hits -1;                                            
 if category NOT IN(1,2,3,4,5) then                                             
       lo := 1;                                                                 
       hi := 5;                                                                 
 else                                                                           
       lo := category;                                                          
       hi := category;                                                          
 end if;                                                                        
 for i in 1..1000 loop                                                          

TEXT                                                                            
--------------------------------------------------------------------------------
         or_num(i) := 0;                                                        
 end loop;                                                                      
 if (((type = 1) or (type = 2)) and (condition =1) and (doc =1)) then           
        k := start_num;                                                         
        open c_kwd_cate(check_vec(1),lo,hi);                                    
        fetch c_kwd_cate into cur_search;                                       
        while c_kwd_cate%FOUND LOOP                                             
            if(parse.wd_and(cur_search.TITLE,1)) then                           
                k := parse.print_result(cur_search,k,start_num,max_hits);       
                tot_hits := tot_hits + 1;                                       
            end if;                                                             

TEXT                                                                            
--------------------------------------------------------------------------------
        fetch c_kwd_cate into cur_search;                                       
        end loop;                                                               
        close c_kwd_cate;                                                       
        alt := parse.makestr;                                                   
        htp.tableClose;                                                         
     --   parse.signature(alt,type,category,doc,condition,max_hits,k,start_num);
                                                                                
                                                                                
  elsif(((type = 1) or (type = 2)) and (condition =1) and (doc =2)) then        
        k := start_num;                                                         
        open c_kwdnot_cate(check_vec(1),lo,hi);                                 

TEXT                                                                            
--------------------------------------------------------------------------------
        fetch c_kwdnot_cate into cur_search;                                    
        while c_kwdnot_cate%FOUND LOOP                                          
            if(parse.wd_and(cur_search.TITLE,1)) then                           
                k := parse.print_result(cur_search,k,start_num,max_hits);       
                tot_hits := tot_hits + 1;                                       
            end if;                                                             
        fetch c_kwdnot_cate into cur_search;                                    
        end loop;                                                               
        close c_kwdnot_cate;                                                    
        alt := parse.makestr;                                                   
        htp.tableClose;                                                         

TEXT                                                                            
--------------------------------------------------------------------------------
      --  parse.signature(alt,type,category,doc,condition,max_hits,k,start_num);
                                                                                
                                                                                
  elsif (((type = 1) or (type = 2)) and (condition =2) and (doc = 1)) then      
        k := start_num ;                                                        
        for i in 1..tot_param loop                                              
             open  c_kwd_cate(check_vec(i),lo,hi);                              
             fetch c_kwd_cate into cur_search;                                  
             while c_kwd_cate%FOUND LOOP                                        
               if(NOT (parse.dupli_fid(cur_search.FID))) then                   
                  k := parse.print_result(cur_search,k,start_num,max_hits);     

TEXT                                                                            
--------------------------------------------------------------------------------
                  tot_hits := tot_hits + 1;                                     
               end if;                                                          
               fetch c_kwd_cate into cur_search;                                
             end loop;                                                          
            close c_kwd_cate;                                                   
        end loop;                                                               
        alt := parse.makestr;                                                   
        htp.tableClose;                                                         
     -- parse.signature(alt,type,category,doc,condition,max_hits,k,start_num);  
  elsif (((type = 1) or (type = 2)) and (condition =2) and (doc = 2)) then      
         k := start_num ;                                                       

TEXT                                                                            
--------------------------------------------------------------------------------
        for i in 1..tot_param loop                                              
             open  c_kwdnot_cate(check_vec(i),lo,hi);                           
             fetch c_kwdnot_cate into cur_search;                               
             while c_kwdnot_cate%FOUND LOOP                                     
               if((NOT(parse.wd_and(cur_search.TITLE,i)))                       
                     AND (NOT(parse.dupli_fid(cur_search.FID)))) then           
                  k := parse.print_result(cur_search,k,start_num,max_hits);     
                  tot_hits := tot_hits + 1;                                     
               end if;                                                          
               fetch c_kwdnot_cate into cur_search;                             
             end loop;                                                          

TEXT                                                                            
--------------------------------------------------------------------------------
            close c_kwdnot_cate;                                                
        end loop;                                                               
        alt := parse.makestr;                                                   
        htp.tableClose;                                                         
      --  parse.signature(alt,type,category,doc,condition,max_hits,k,start_num);
                                                                                
                                                                                
  elsif(type =4) then                                                           
     select count(*) into cnt from SEARCH                                       
                          WHERE (FTYPE BETWEEN lo AND hi);                      
     tot_hits := cnt;                                                           

TEXT                                                                            
--------------------------------------------------------------------------------
     if cnt > end_num then                                                      
           ht_num := end_num;                                                   
     else                                                                       
           ht_num := cnt;                                                       
     end if;                                                                    
     open c_cate_list(lo,hi);                                                   
     fetch c_cate_list into cur_search;                                         
     if (start_num = 1) then                                                    
         for i in 1..ht_num loop                                                
                k := k+1 ;                                                      
                srch := cur_search;                                             

TEXT                                                                            
--------------------------------------------------------------------------------
                parse.table_row(srch,k);                                        
                fetch c_cate_list into cur_search;                              
          end loop;                                                             
          ht_num := ht_num + 1;                                                 
     else                                                                       
          for i in 1..(start_num-1) loop                                        
               fetch c_cate_list into cur_search;                               
          end loop;                                                             
          k := start_num;                                                       
          for i in k..ht_num loop                                               
                srch := cur_search;                                             

TEXT                                                                            
--------------------------------------------------------------------------------
                parse.table_row(srch,k);                                        
                fetch c_cate_list into cur_search;                              
                k := K + 1;                                                     
          end loop;                                                             
          ht_num := ht_num +1;                                                  
    end if;                                                                     
    close c_cate_list;                                                          
   k := ht_num;                                                                 
    htp.tableClose;                                                             
 --   parse.signature(alt,type,category,doc,condition,max_hits,ht_num,start_num)
;                                                                               

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
   end if;                                                                      
<<end_of_table>>                                                                
 htp.p('</center>');                                                            
  parse.signature(alt,type,category,doc,condition,max_hits,k,start_num);        
  parse.ini_page;                                                               
   exception                                                                    
       when no_data_found then                                                  
               htp.p('Search found no matches.');                               
   htp.bodyClose;                                                               
   htp.htmlClose;                                                               

TEXT                                                                            
--------------------------------------------------------------------------------
end;                                                                            
---------------------------------------------------------------------           
function print_result(cur_search in search%rowtype,j in number,start_num in numb
er,max_hits in number)                                                          
                                                                                
                        return number is                                        
srch search%rowtype;                                                            
k NUMBER := j;                                                                  
begin                                                                           
if((start_num = 1) AND (k <= max_hits)) then                                    
     or_num(k) := cur_search.FID;                                               

TEXT                                                                            
--------------------------------------------------------------------------------
     srch := cur_search;                                                        
     parse.table_row(srch,k);                                                   
     tot_fids := tot_fids +1;                                                   
     k := k+1;                                                                  
elsif((start_num > 1)AND (k <= end_num)) then                                   
     if (done = 1) then                                                         
         or_num(k) := cur_search.FID;                                           
         srch := cur_search;                                                    
         parse.table_row(srch,k);                                               
         tot_fids := tot_fids+1;                                                
         k := k+1;                                                              

TEXT                                                                            
--------------------------------------------------------------------------------
     else                                                                       
         row_count := row_count +1;                                             
         or_num(row_count) := cur_search.FID;                                   
         tot_fids := tot_fids+1;                                                
         if (row_count = start_num-1) then                                      
             done := 1;                                                         
         end if;                                                                
     end if;                                                                    
end if;                                                                         
return k;                                                                       
end;                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
------------------------------------------------------------                    
procedure table_row(c_name in  search%rowtype ,k in number) is                  
base_url varchar2(2000) := '<a href="http://kayak.npac.syr.edu:1963/cgi-bin/thin
k/hl?';                                                                         
                                                                                
begin                                                                           
     parse.convert(c_name.FTYPE);                                               
     htp.tableRowopen('CENTER','MIDDLE');                                       
     htp.tableData(k,'LEFT');                                                   
     htp.tableData(c_name.FID,'MIDDLE');                                        
     htp.tableData(base_url ||c_name.FID||'" TARGET="bottom">'||replace(c_name.T

TEXT                                                                            
--------------------------------------------------------------------------------
ITLE,'""','''')||'</a>','LEFT');                                                
                                                                                
     htp.tableData(con_name(1),'CENTER','NOWRAP',cattributes=>'valign="MIDDLE"')
;                                                                               
                                                                                
     htp.tableData(ROUND(c_name.FSIZE/1024.0,1),'LEFT');                        
     htp.tableData(TO_CHAR(c_name.TIME,'MM/DD/YY'));                            
end;                                                                            
------------------------------------------------------                          
procedure signature(alt in varchar2,type in number,category in number,doc in num
ber,                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
condition in number,max_hits in number,k in number, start_num in number) is     
begin                                                                           
if (start_num =1) then                                                          
     htp.tableOpen(cattributes=>'WIDTH="100%"');                                
     htp.tableRowOpen;                                                          
     htp.tableData('Total Items Found: <B>'||tot_hits||'</B>','CENTER','NOWRAP',
cattributes=>'WIDTH="50%"');                                                    
                                                                                
     htp.tableData(parse.sig(alt,type,category,doc,condition,max_hits,k),'CENTER
',cattributes=>'WIDTH="50%"');                                                  

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
     htp.tableClose;                                                            
elsif(k > max_hits-1) then                                                      
     htp.tableOpen(cattributes=>'WIDTH="100%"');                                
     htp.tableRowOpen;                                                          
     htp.tableData(parse.sigpre(alt,type,category,doc,condition,max_hits,k),'LEF
T',cattributes=>'WIDTH="33%"');                                                 
                                                                                
     htp.tableData('Total Items Found: <b>'||tot_hits||'</b>','CENTER','NOWRAP',
cattributes=>'WIDTH="34%"');                                                    
                                                                                

TEXT                                                                            
--------------------------------------------------------------------------------
     htp.tableData(parse.sig(alt,type,category,doc,condition,max_hits,k),'RIGHT'
,cattributes=>'WIDTH="33%"');                                                   
                                                                                
     htp.tableClose;                                                            
    end if;                                                                     
end;                                                                            
-----------------------------------------------------------------------         
procedure convert (val in number) is                                            
begin                                                                           
if (val = 1) then                                                               
       con_name(1) := 'Science and Math';                                       

TEXT                                                                            
--------------------------------------------------------------------------------
elsif (val = 2) then                                                            
        con_name(1) := 'Arts and Literature';                                   
elsif (val = 3) then                                                            
        con_name(1) := 'Social Science';                                        
elsif (val = 4) then                                                            
        con_name(1) :=  'Sports';                                               
elsif (val = 5) then                                                            
        con_name(1) := 'Interdisciplinary';                                     
else                                                                            
         con_name (1) := 'Undefined';                                           
end if;                                                                         

TEXT                                                                            
--------------------------------------------------------------------------------
end;                                                                            
-----------------------------------------------------------------------         
function wd_and(title in varchar2,num in number) return boolean is              
checknum NUMBER := 0;                                                           
i number;                                                                       
count_y NUMBER := 0;                                                            
begin                                                                           
   for i in 1..tot_param loop                                                   
   if (i != num) then                                                           
      checknum := INSTR(UPPER(title),UPPER(check_vec(i)),1);                    
      if checknum != 0 then                                                     

TEXT                                                                            
--------------------------------------------------------------------------------
                count_y := count_y + 1;                                         
                checknum := 0;                                                  
      end if;                                                                   
   end if;                                                                      
   end loop;                                                                    
   if (count_y != (tot_param - 1)) then                                         
              return false;                                                     
   else                                                                         
      return true;                                                              
   end if;                                                                      
end;                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
---------------------------------------------------------------------           
procedure wd_cate_or(lo in number,hi in number) is                              
cursor srch_or(k_word in varchar2,lo in number,hi in number) is                 
               select * from SEARCH                                             
               where ((upper(TITLE) like '%'||upper(k_word)||'%') AND           
                (FTYPE BETWEEN lo AND hi))                                      
               order by FTYPE,TITLE;                                            
cur_search search%rowtype;                                                      
srch search%rowtype;                                                            
i number;                                                                       
k number := tot_fids;                                                           

TEXT                                                                            
--------------------------------------------------------------------------------
begin                                                                           
     for i in 1..tot_param loop                                                 
             open srch_or(check_vec(i),lo,hi);                                  
             fetch srch_or into cur_search;                                     
             while srch_or%FOUND LOOP                                           
               if(NOT (parse.dupli_fid(cur_search.FID))) then                   
                  k := k+1;                                                     
                  or_num(k) := cur_search.FID;                                  
                  srch := cur_search;                                           
                  parse.table_row(srch,k);                                      
                  tot_fids := tot_fids+1;                                       

TEXT                                                                            
--------------------------------------------------------------------------------
               end if;                                                          
               fetch srch_or into cur_search;                                   
            end loop;                                                           
            close srch_or;                                                      
     end loop;                                                                  
        htp.tableClose;                                                         
end;                                                                            
---------------------------------------------------------------------           
function dupli_fid(val in number) return boolean is                             
k number;                                                                       
ch number:= 0;                                                                  

TEXT                                                                            
--------------------------------------------------------------------------------
begin                                                                           
  <<loop_one>>                                                                  
   for  k in 1..tot_fids loop                                                   
      if (or_num(k) = val) then                                                 
           ch := 1;                                                             
           return true;                                                         
           exit loop_one;                                                       
      end if;                                                                   
   end loop;                                                                    
   if (ch = 0) then                                                             
           return false;                                                        

TEXT                                                                            
--------------------------------------------------------------------------------
   end if;                                                                      
end;                                                                            
--------------------------------------------------------------------------------
-----                                                                           
                                                                                
function sig(query_text in varchar2,type in number, category in number,         
              doc in number,condition in number,max_hits in number,end_num in nu
mber) return varchar2 is                                                        
                                                                                
base_url varchar2(255) := 'http://kayak.npac.syr.edu:1963/cgi-bin/think/wow/pars
e.';                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
alt varchar2(200) := query_text;                                                
num number(10) :=0;                                                             
begin                                                                           
num := end_num + max_hits-1;                                                    
if tot_hits < num then                                                          
   num := tot_hits;                                                             
end if;                                                                         
if end_num > tot_hits then                                                      
 return null;                                                                   
else                                                                            

TEXT                                                                            
--------------------------------------------------------------------------------
return('<a href="'||base_url||'searchresult?query_text='||alt||chr(ascii('&'))||
                                                                                
                                                                                
                      'type='||type||chr(ascii('&'))||'category='||category||chr
(ascii('&'))||                                                                  
                                                                                
                      'doc='||doc||chr(ascii('&'))||'condition='||condition||chr
(ascii('&'))||                                                                  
                                                                                
                      'max_hits='||max_hits||chr(ascii('&'))||'start_num='||end_
num||chr(ascii('&'))||                                                          

TEXT                                                                            
--------------------------------------------------------------------------------
                                                                                
                      '">Next </a>('||end_num||'-'||num||')');                  
end if;                                                                         
end;                                                                            
--------------------------------------------------------------------------------
---                                                                             
                                                                                
function sigpre(alt in varchar2,type in number, category in number,             
              doc in number,condition in number,max_hits in number,end_num in nu
mber) return varchar2 is                                                        
                                                                                

TEXT                                                                            
--------------------------------------------------------------------------------
base_url varchar2(255) := 'http://kayak.npac.syr.edu:1963/cgi-bin/think/wow/pars
e.';                                                                            
                                                                                
act_num NUMBER :=end_num;                                                       
num NUMBER :=0;                                                                 
begin                                                                           
if (MOD((end_num-1),max_hits) != 0) then                                        
   while (MOD((act_num-1),max_hits) != 0) loop                                  
       act_num := act_num -1;                                                   
   end loop;                                                                    
   act_num := act_num - max_hits;                                               

TEXT                                                                            
--------------------------------------------------------------------------------
else                                                                            
   act_num := end_num - (2*max_hits);                                           
end if;                                                                         
if act_num < 1 then                                                             
   act_num := 1;                                                                
end if;                                                                         
num := act_num + max_hits-1;                                                    
--act_num := act_num - max_hits;                                                
return                                                                          
('<a href="'||base_url||'searchresult?query_text='||alt||chr(ascii('&'))||      
                      'type='||type||chr(ascii('&'))||'category='||category||chr

TEXT                                                                            
--------------------------------------------------------------------------------
(ascii('&'))||                                                                  
                                                                                
                      'doc='||doc||chr(ascii('&'))||'condition='||condition||chr
(ascii('&'))||                                                                  
                                                                                
                      'max_hits='||max_hits||chr(ascii('&'))||'start_num='||act_
num||chr(ascii('&'))||                                                          
                                                                                
                       '">Previous  </a>('||act_num||'-'||num||')');            
end;                                                                            
--------------------------------------------------------------------------------

TEXT                                                                            
--------------------------------------------------------------------------------
---                                                                             
                                                                                
function makestr  return varchar2 is                                            
i number;                                                                       
str varchar2(2000);                                                             
begin                                                                           
  for i in 1..(tot_param-1) loop                                                
   str := str||LTRIM(RTRIM(check_vec(i)))||'+';                                 
  end loop;                                                                     
  str := str||check_vec(tot_param);                                             
  return str;                                                                   

TEXT                                                                            
--------------------------------------------------------------------------------
end;                                                                            
--------------------------------                                                
end;                                                                            

534 rows selected.

SQL> spool off;
