create or replace package wow is
	type web_page is table of varchar2(255)
	index by binary_integer;
	procedure sig;
	procedure sig(cname in varchar2);
    procedure get_page (thepage     out htp.htbuf_arr,
                       irows    in out integer );
	wowgif varchar2(255) := '/images/small_mall.gif';
end; -- <hr>
/
create or replace package body wow is -- <p>

	invocations integer := 1;


	procedure sig is
	begin
		htp.line;
	htp.p('<a href="http://www.infomall.org/">InfoMall</a>'||' at <tt>'||
			to_char(sysdate,'Dy, mm/dd/yy hh24:mi') || 
			' EST</tt> from <a href="http://kayak.npac.syr.edu:1963/">AskNPAC</a></html>');
	end; -- <p> 

	procedure sig(cname in varchar2) is
	begin
		sig;
		htp.linkRel('/cgi-bin/wow/wow.showsource?cname=' || cname,
		'Inspect pl/sql source code');
	end; -- <p>

 /*****************************************/   
    /* OWA's Get the output from the user's PL/SQL */
   /*****************************************/
procedure get_page (thepage     out htp.htbuf_arr,
                       irows    in out integer ) is
   begin
      irows := least(irows,htp.rows_in - htp.rows_out);

      for i in 1..irows
      loop
         thepage(i) := htp.htbuf(htp.rows_out+i);
      end loop;

      htp.rows_out := htp.rows_out + irows;
   end;
end;
/
show errors





